> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# List data query jobs

GET https://rest.test.zuora.com/query/jobs

Returns a list of [data query](https://knowledgecenter.zuora.com/DC_Developers/BA_Data_Query) jobs that have been created in your Zuora tenant. You can filter the list by status.

If you are an administrator, you can retrieve all the query jobs in your tenant. Otherwise, you can only retrieve your own query jobs.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/data-query/data-queries/get-data-query-jobs

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `queryStatus` (enum, optional) — Filters the list of query jobs by status.
  - Allowed values: `accepted`, `in_progress`, `completed`, `failed`, `cancelled`
- `pageSize` (integer, optional, default: 20) — The number of records returned per page in the response.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

## Response

### 200

OK

- `data` (list of DataQueryJob, optional) — List of data query jobs. The query jobs are listed in reverse order of creation.

## Types

### DataQueryJob

A data query job.

- `createdBy` (string, optional) — The query job creator's Id.
- `id` (string, optional) — Internal identifier of the query job.
- `query` (string, optional) — The query that was submitted.
- `remainingRetries` (integer, optional) — The number of times that Zuora will retry the query if Zuora is unable to perform the query.
- `sourceData` (string, optional) — Indicates the source that data queries run against: * `LIVE` represents the live transactional databases at Zuora (Data Query Live). * `WAREHOUSE` represents Zuora Warehouse, which has better performance and fewer limitations than the live transactional database. For more information, see Zuora Warehouse.
- `updatedOn` (datetime, optional) — Date and time when the query job was last updated, in ISO 8601 format.
- `useIndexJoin` (boolean, optional) — Indicates whether to use Index Join. See Index Join for more information.
- `dataFile` (string, optional) — The URL of the query results. Only applicable if the value of the `queryStatus` field is `completed`.
- `outputRows` (integer, optional) — The number of rows the query results. Only applicable if the value of the `queryStatus` field is `completed`.
- `processingTime` (integer, optional) — Processing time of the query job, in milliseconds. Only applicable if the value of the `queryStatus` field is `completed`.
- `queryStatus` (enum, optional) — Status of the query job. * `submitted` - query submitted to query service for processing * `accepted` - query accepted by the query service * `in_progress` - query executed by the query service * `completed` - query execution completed by the query service * `failed` - query unable to be processed by the query service * `cancelled` - query cancelled by the user If the value of this field is `completed`, the `dataFile` field contains the location of the query results. If the value of this field is `accepted` or `in_progress`, you can use [Cancel a data query job](#operation/DELETE_DataQueryJob) to prevent Zuora from performing the query. Zuora then sets the status of the query job to `cancelled`.
  - Allowed values: `submitted`, `accepted`, `in_progress`, `completed`, `failed`, `cancelled`

## Examples

**Response**

```json
{
  "data": [
    {
      "createdBy": "514f3ea1-6716-4f44-b6e0-9a8f0cf44bd2",
      "id": "bf3b5640-ddd1-4b4f-9a81-906ec2b84a89",
      "query": "SELECT s.id FROM Subscription s JOIN RatePlan rp ON s.id = rp.subscriptionid WHERE rp.name = 'Premium Monthly'",
      "remainingRetries": 3,
      "sourceData": "LIVE",
      "updatedOn": "2018-08-17T13:14:38.855Z",
      "useIndexJoin": false,
      "queryStatus": "in_progress"
    },
    {
      "createdBy": "514f3ea1-6716-4f44-b6e0-9a8f0cf44bd2",
      "id": "3a3e85c4-96e7-486b-ae02-827120104301",
      "query": "SELECT accountnumber, balance FROM Account WHERE Account.balance > 100",
      "remainingRetries": 3,
      "sourceData": "LIVE",
      "updatedOn": "2018-08-17T13:14:19.17Z",
      "useIndexJoin": false,
      "dataFile": "https://example.s3.us-west-2.amazonaws.com/3a3e85c4-96e7-486b-ae02-827120104301_24921638725108715.json?X-Amz-Security-Token=...",
      "outputRows": 24516,
      "processingTime": 9212,
      "queryStatus": "completed"
    }
  ]
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/query/jobs"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/query/jobs';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/query/jobs"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/query/jobs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/query/jobs")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/query/jobs', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/query/jobs");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/query/jobs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```